// TL_View.cpp : implementation file
// Trace Logs Viewer

#include "stdafx.h"
#include "diff_trace.h"
#include "diff_traceDlg.h"
#include "TL_View.h"
//#include "MyListCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#define TL_ALL 0
#define TL_First 1
#define TL_Second 2





/////////////////////////////////////////////////////////////////////////////
// TL_View dialog


TL_View::TL_View(CWnd* pParent /*=NULL*/)
	: CDialog(TL_View::IDD, pParent)
{
	//{{AFX_DATA_INIT(TL_View)
	//}}AFX_DATA_INIT
}


void TL_View::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(TL_View)
	DDX_Control(pDX, IDC_BORDER_2_REACHED, m_border2);
	DDX_Control(pDX, IDC_BORDER_1_REACHED, m_border1);
	DDX_Control(pDX, IDC_CHECK_SYNC, m_sync);
	DDX_Control(pDX, IDC_STATIC_PATH_2, m_static_name2);
	DDX_Control(pDX, IDC_STATIC_PATH_1, m_static_name1);
	DDX_Control(pDX, IDC_GOTO_2, m_combo_goto2);
	DDX_Control(pDX, IDC_GOTO_1, m_combo_goto1);
	DDX_Control(pDX, IDC_VIEW_2, m_view_2);
	DDX_Control(pDX, IDC_VIEW_1, m_view_1);
	DDX_Control(pDX, IDC_NAVIGATE_2_PLUS_10, m_navigate_2_plus10);
	DDX_Control(pDX, IDC_NAVIGATE_2_PLUS_1, m_navigate_2_plus1);
	DDX_Control(pDX, IDC_NAVIGATE_2_MINUS_10, m_navigate_2_minus10);
	DDX_Control(pDX, IDC_NAVIGATE_2_MINUS_1, m_navigate_2_minus1);
	DDX_Control(pDX, IDC_NAVIGATE_1_PLUS_10, m_navigate_1_plus10);
	DDX_Control(pDX, IDC_NAVIGATE_1_PLUS_1, m_navigate_1_plus1);
	DDX_Control(pDX, IDC_NAVIGATE_1_MINUS_10, m_navigate_1_minus10);
	DDX_Control(pDX, IDC_NAVIGATE_1_MINUS_1, m_navigate_1_minus1);
	DDX_Control(pDX, IDC_GO_2, m_goto_tl_2);
	DDX_Control(pDX, IDC_GO_1, m_goto_tl_1);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(TL_View, CDialog)
	//{{AFX_MSG_MAP(TL_View)
	ON_BN_CLICKED(IDC_CHECK_SYNC, OnCheckSync)
	ON_BN_CLICKED(IDC_GO_1, OnGoLine_1)
	ON_BN_CLICKED(IDC_GO_2, OnGoLine_2)
	ON_BN_CLICKED(IDC_NAVIGATE_1_PLUS_1, OnNavigate1Plus1)
	ON_BN_CLICKED(IDC_NAVIGATE_1_PLUS_10, OnNavigate1Plus10)
	ON_BN_CLICKED(IDC_NAVIGATE_1_MINUS_1, OnNavigate1Minus1)
	ON_BN_CLICKED(IDC_NAVIGATE_1_MINUS_10, OnNavigate1Minus10)
	ON_BN_CLICKED(IDC_NAVIGATE_2_MINUS_10, OnNavigate2Minus10)
	ON_BN_CLICKED(IDC_NAVIGATE_2_MINUS_1, OnNavigate2Minus1)
	ON_BN_CLICKED(IDC_NAVIGATE_2_PLUS_1, OnNavigate2Plus1)
	ON_BN_CLICKED(IDC_NAVIGATE_2_PLUS_10, OnNavigate2Plus10)
//	ON_BN_CLICKED(IDC_HIGHLIGHT, OnHighlight)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// TL_View message handlers

BOOL TL_View::OnInitDialog()
{
	CDialog::OnInitDialog();
//
	//
//	m_view_1.SetStile(LVS_REPORT | LVS_OWNERDRAWFIXED |LVS_EDITLABELS);
//	m_view_2.SetStile(LVS_REPORT | LVS_OWNERDRAWFIXED |LVS_EDITLABELS);

m_view_1.InsertColumn(0,"Position 1",LVCFMT_LEFT,100);
m_view_1.InsertColumn(1,"=",LVCFMT_LEFT,25);;
m_view_1.InsertColumn(2,"Address 1",LVCFMT_LEFT,100);
m_view_1.InsertColumn(3,"Text 1",LVCFMT_LEFT,240);

m_view_2.InsertColumn(0,"Position 2",LVCFMT_LEFT,100);
m_view_2.InsertColumn(1,"=",LVCFMT_LEFT,25);;
m_view_2.InsertColumn(2,"Address 2",LVCFMT_LEFT,100);
m_view_2.InsertColumn(3,"Text 2",LVCFMT_LEFT,240);

TBMP_TRUE.LoadBitmap(IDB_TRUE);
TBMP_FALSE.LoadBitmap(IDB_FALSE);

SYNC_View=0;

::SetWindowText(m_static_name1.m_hWnd,&name_file1[0]);
::SetWindowText(m_static_name2.m_hWnd,&name_file2[0]);

SHOW_TEXT_DATA(TL_ALL);

	return 0;
}


void TL_View::SHOW_TEXT_DATA (long TraceLogs)
{
	ULONG f;
//	register DWORD Dmain = 0x6E69616D;
	m_border1.SetBitmap(TBMP_FALSE);
	m_border2.SetBitmap(TBMP_FALSE);
	UINT save_n1=n1;
	UINT save_n2=n2;
	if(!Pointer1)
	{
		Pointer1=reinterpret_cast<DWORD>(Alloc1);
	}
	if(!Pointer2)
	{
		Pointer2=reinterpret_cast<DWORD>(Alloc2);
	}

	memset(&Cmp1[0],0,sizeof(Cmp1[DEEP_VIEW]));
	memset(&Cmp2[0],0,sizeof(Cmp2[DEEP_VIEW]));

	memset(&CmpPointers1[0],0,sizeof(CmpPointers1[DEEP_VIEW]));
	memset(&CmpPointers2[0],0,sizeof(CmpPointers2[DEEP_VIEW]));
	
ULONG i;
//if(TraceLogs == TL_Second)
//{
//	goto A1;
//}
m_view_1.DeleteAllItems();
	for(i=DEEP_VIEW;i>0;i--)
	{
		if((Pointer1-(unsigned long)Alloc1)>Fileh1Size)
		{
			m_border1.SetBitmap(TBMP_TRUE);
			break;
		}
	Pointer1--;

			do
			{
					Pointer1++;
						if((Pointer1-(unsigned long)Alloc1)>Fileh1Size)
						{
						m_border1.SetBitmap(TBMP_TRUE);
						goto A1;
						}
				

			}
			while(*(LPDWORD)(Pointer1)!= 0x6E69616D);
	
				CmpPointers1[i]=Pointer1;
				memcpy(&sbuffer[0],(const void*)((DWORD)Pointer1+6),10);
				sbuffer[10]='\0';
				sscanf(&sbuffer[0],"%x",&f);
				Cmp1[i] = f;

				////////////////

		
				Pointer1+=38;
		}


//	if(TraceLogs == TL_First)
//{
//	goto A2;
//}
A1:
m_view_2.DeleteAllItems();
///// 2ND LIST ///////
	for(i=DEEP_VIEW;i>0;i--)
	{
		if((Pointer2-(unsigned long)Alloc2)>Fileh2Size)
		{
			m_border2.SetBitmap(TBMP_TRUE);
			break;
		}
	Pointer2--;

			do
			{
					Pointer2++;
						if((Pointer2-(unsigned long)Alloc2)>Fileh1Size)
						{
						m_border2.SetBitmap(TBMP_TRUE);
						goto A2;
						}
				

			}
			while(*(LPDWORD)(Pointer2)!= 0x6E69616D);
	
				CmpPointers2[i]=Pointer2;
				memcpy(&sbuffer[0],(const void*)((DWORD)Pointer2+6),10);
				sbuffer[10]='\0';
				sscanf(&sbuffer[0],"%x",&f);
				Cmp2[i] = f;
				/////////////////////////
				
			
				
				Pointer2+=38;
	}


A2:

		for(i=DEEP_VIEW;i>0;i--)

		{
			if(Cmp1[i]!=0)
			{
				for(f=DEEP_VIEW;f>0;f--)
				{
					if(Cmp2[f]!=0)
						{
							if(Cmp1[i] == Cmp2[f])
							{
								Cmp1[i]=highlight_address;
								Cmp2[f]=highlight_address;
							}
						}
				}
			}
		}

		for(i=DEEP_VIEW;i>0;i--)
		//for(i=1;i<DEEP_VIEW;i++)
		{
			if(CmpPointers1[i]!=0)
			{
				CurrentView=LIST_VIEW_NUMBER_1;
				ltoa(n1,&sbuffer[0],10);
				m_view_1.InsertItem(0,(LPCSTR)(&sbuffer[0]));

				if(Cmp1[i]==highlight_address)
				{
					m_view_1.SetItemText(0,1,"*");
				}
	

				memcpy(&sbuffer[0],(const void*)((DWORD)CmpPointers1[i]+6),10);
				sbuffer[10]='\0';
				m_view_1.SetItemText(0,2,(LPCSTR)(&sbuffer[0]));

				UINT a=0;
				Pointer1=CmpPointers1[i];
				do
				{
				//memcpy(&sbuffer[0],(const void*)((DWORD)Pointer1+34),20);
				memcpy(&sbuffer[a],(const void*)((DWORD)Pointer1+34),1);
					a++;
					Pointer1++;
				}while(*(LPWORD)(Pointer1+34)!=0x0A0D);
				sbuffer[a]='\0';
			
				m_view_1.SetItemText(0,3,(LPCSTR)(&sbuffer[0]));
				m_view_1.m_hWnd;
			
			n1++;
			}

			if(CmpPointers2[i]!=0)
			{
			
				ltoa(n2,&sbuffer[0],10);
				m_view_2.InsertItem(0,(LPCSTR)(&sbuffer[0]));
	
				if(Cmp2[i]==highlight_address)
				{
					m_view_2.SetItemText(0,1,"*");
				}
				memcpy(&sbuffer[0],(const void*)((DWORD)CmpPointers2[i]+6),10);
				sbuffer[10]='\0';
				m_view_2.SetItemText(0,2,(LPCSTR)(&sbuffer[0]));

				UINT a=0;
				Pointer2=CmpPointers2[i];
				do
				{
				
				memcpy(&sbuffer[a],(const void*)((DWORD)Pointer2+34),1);
					a++;
					Pointer2++;
				}while(*(LPWORD)(Pointer2+34)!=0x0A0D);
				sbuffer[a]='\0';
			
				m_view_2.SetItemText(0,3,(LPCSTR)(&sbuffer[0]));
				CurrentView=LIST_VIEW_NUMBER_2;
			
			n2++;
			}
		}
 n1=save_n1;
n2=save_n2;

}

	
	



//	m_view_2.InsertItem(0,(LPCSTR)(&sbuffer[0]));
//	m_view_1.SetItemText(0,0,(LPCSTR)(&sbuffer[0]));
//	m_view_2.SetItemText(0,0,(LPCSTR)(&sbuffer[0]));


void TL_View::OnCheckSync() 
{
	// TODO: Add your control notification handler code here
	
	if(m_sync.GetCheck())
	{
		m_navigate_2_plus10.EnableWindow(false);
		m_navigate_2_plus1.EnableWindow(false);
		m_navigate_2_minus10.EnableWindow(false);
		m_navigate_2_minus1.EnableWindow(false);
		m_combo_goto2.EnableWindow(false);
		m_goto_tl_2.EnableWindow(false);
		SYNC_View=1;
	}
	else
	{
		m_navigate_2_plus10.EnableWindow(true);
		m_navigate_2_plus1.EnableWindow(true);
		m_navigate_2_minus10.EnableWindow(true);
		m_navigate_2_minus1.EnableWindow(true);
		m_combo_goto2.EnableWindow(true);
		m_goto_tl_2.EnableWindow(true);
		SYNC_View=0;
	}
	
}

void TL_View::OnGoLine_1() 
{
	// TODO: Add your control notification handler code here
	//GetWindowText(m_one_string.m_hWnd,&buf[0],32);

	::GetWindowText(m_combo_goto1.m_hWnd, &sbuffer[0],16);
	n1 = atol(&sbuffer[0]);
	
	
	if(SYNC_View)
	{
	n2=n1;
		OWN_Find_pointers();
		SHOW_TEXT_DATA (TL_ALL);
	}
	else
	{
//	::GetWindowText(m_combo_goto2.m_hWnd, &sbuffer[0],16);
//	n2 = atol(&sbuffer[0]);
	//	n2=0;
	OWN_Find_pointers();
		SHOW_TEXT_DATA (TL_First);
	}
	::GetWindowText(m_combo_goto1.m_hWnd, &sbuffer[0],16);
	m_combo_goto1.InsertString(0,&sbuffer[0]);

	
}

void TL_View::OnGoLine_2() 
{
	// TODO: Add your control notification handler code here
//	n1=0;
	::GetWindowText(m_combo_goto2.m_hWnd, &sbuffer[0],16);
	n2 = atol(&sbuffer[0]);
	OWN_Find_pointers();
		SHOW_TEXT_DATA (TL_Second);

	::GetWindowText(m_combo_goto2.m_hWnd, &sbuffer[0],16);
	m_combo_goto2.InsertString(0,&sbuffer[0]);
}

void TL_View::OnNavigate1Plus1() 
{
	// TODO: Add your control notification handler code here
n1++;
	
	
	if(SYNC_View)
	{
	n2=n1;
		OWN_Find_pointers();
		SHOW_TEXT_DATA (TL_ALL);
	}
	else
	{
//	::GetWindowText(m_combo_goto2.m_hWnd, &sbuffer[0],16);
//	n2 = atol(&sbuffer[0]);
	//	n2=0;
	OWN_Find_pointers();
		SHOW_TEXT_DATA (TL_First);
	}
	
}

void TL_View::OnNavigate1Plus10() 
{
	// TODO: Add your control notification handler code here
	n1+=10;
	
	
	if(SYNC_View)
	{
	n2=n1;
		OWN_Find_pointers();
		SHOW_TEXT_DATA (TL_ALL);
	}
	else
	{
//	::GetWindowText(m_combo_goto2.m_hWnd, &sbuffer[0],16);
//	n2 = atol(&sbuffer[0]);
	//	n2=0;
	OWN_Find_pointers();
		SHOW_TEXT_DATA (TL_First);
	}
	
}

void TL_View::OnNavigate1Minus1() 
{
	// TODO: Add your control notification handler code here
		if(!n1--)
		{
				m_border1.SetBitmap(TBMP_TRUE);
				n1=0;
				return;
		}
	
	
	if(SYNC_View)
	{
	n2=n1;
		OWN_Find_pointers();
		SHOW_TEXT_DATA (TL_ALL);
	}
	else
	{
//	::GetWindowText(m_combo_goto2.m_hWnd, &sbuffer[0],16);
//	n2 = atol(&sbuffer[0]);
	//	n2=0;
	OWN_Find_pointers();
		SHOW_TEXT_DATA (TL_First);
	}
	
}

void TL_View::OnNavigate1Minus10() 
{
	// TODO: Add your control notification handler code here
			if(n1<10)
		{
				m_border1.SetBitmap(TBMP_TRUE);
				n1=0;
				return;
		}
	
	n1=n1-10;
	if(SYNC_View)
	{
	n2=n1;
		OWN_Find_pointers();
		SHOW_TEXT_DATA (TL_ALL);
	}
	else
	{
//	::GetWindowText(m_combo_goto2.m_hWnd, &sbuffer[0],16);
//	n2 = atol(&sbuffer[0]);
		n2=0;
	OWN_Find_pointers();
		SHOW_TEXT_DATA (TL_First);
	}
	
}

void TL_View::OnNavigate2Minus10() 
{
	// TODO: Add your control notification handler code here

				if(n2<10)
		{
				m_border2.SetBitmap(TBMP_TRUE);
				n2=0;
				return;
		}
	

	n2=n2-10;
	OWN_Find_pointers();
		SHOW_TEXT_DATA (TL_Second);

	

	
}

void TL_View::OnNavigate2Minus1() 
{
	// TODO: Add your control notification handler code here

			if(!n2--)
		{
				m_border2.SetBitmap(TBMP_TRUE);
				n2=0;
				return;
		}
	

//	::GetWindowText(m_combo_goto2.m_hWnd, &sbuffer[0],16);
//	n2 = atol(&sbuffer[0]);
	
	OWN_Find_pointers();
		SHOW_TEXT_DATA (TL_Second);
	
	
}

void TL_View::OnNavigate2Plus1() 
{
	// TODO: Add your control notification handler code here
		n2+=1;
	

	OWN_Find_pointers();
		SHOW_TEXT_DATA (TL_Second);
	
}

void TL_View::OnNavigate2Plus10() 
{
	// TODO: Add your control notification handler code here
			n2+=10;
	

	OWN_Find_pointers();
		SHOW_TEXT_DATA (TL_Second);
}

bool TL_View::OWN_Find_pointers()
{
	m_border1.SetBitmap(TBMP_FALSE);
	m_border2.SetBitmap(TBMP_FALSE);
(DWORD)Pointer1 = (unsigned long)Alloc1;
(DWORD)Pointer2 = (unsigned long)Alloc2;

unsigned int Stroka_1=0;
unsigned int Stroka_2=0;

	switch(SYNC_View)
	{
	case true:
		{
			
			Pointer2--;
			do
							{
								if(*(LPDWORD)(Pointer1)==0x6E69616D)
								{
								
								
				
											do
											{
												Pointer2++;

												if((Pointer2-(unsigned long)Alloc2)>Fileh2Size)
												{
														m_border2.SetBitmap(TBMP_TRUE);
													return 0;
												}
											}while(*(LPDWORD)(Pointer2)!=0x6E69616D);

									if(Stroka_1>=n1)
									{
										n1=n2;
										return 1;
									}
									Stroka_1++;
									Pointer2+=38;
									Pointer1+=38;
								}

									
								
								Pointer1++;

							}while(Pointer1-(unsigned long)Alloc1<Fileh1Size);
		}
		m_border1.SetBitmap(TBMP_TRUE);
	break;
	case false:
	{
	
		//warning! code search async two pointers, but now use one result.

		do
		{
				if(*(LPDWORD)(Pointer1)==0x6E69616D)
								{
								
								
										if(Stroka_1++ >= n1)
										{
											do
											{
													if(*(LPDWORD)(Pointer2) ==0x6E69616D)
													{
													
														
															if(Stroka_2++ >= n2)
															{
																	//	if(((*(LPDWORD)(Pointer1+6)) != (*(LPDWORD)(Pointer2+6)))&&((*(LPDWORD)(Pointer1+10)) != (*(LPDWORD)(Pointer2+10))))
																	//		{
																	//			ltoa(n1,&sbuffer[0],10);
															

																			return 1;
																	//		}
															
															}
															else
															{
															
																Pointer2+=38;
															
															}
													}
													
												Pointer2++;
											}while((Pointer2-(unsigned long)Alloc2<Fileh2Size));
											m_border2.SetBitmap(TBMP_TRUE);
											break;
										}
											Pointer1+=38;
								}
				Pointer1++;

		}
		while((Pointer1-(unsigned long)Alloc1<Fileh1Size));
	m_border1.SetBitmap(TBMP_TRUE);
	}
	break;	
	

	
}

return 0;
}

void TL_View::OnHighlight() 
{
	/*
	UINT f;
	
	// TODO: Add your control notification handler code here
	for(UINT i=m_view_1.GetItemCount();i>0;i--)
	{
		m_view_1.GetItemText(i,1,&sbuffer[0],8);
		
		sscanf(&sbuffer[0],"%x",&f);
		Cmp1[i] = f;
	}
		for(i=m_view_2.GetItemCount();i>0;i--)
	{
		m_view_2.GetItemText(i,1,&sbuffer[0],8);
		sscanf(&sbuffer[0],"%x",&f);
		Cmp2[i] = f;
	}

	*/
}
